<?php

namespace App\Http\Controllers\Website;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\Contactu;
use App\Models\User;
use App\Http\Controllers\Website\EmailController;
use Illuminate\Support\Facades\Mail;
use Illuminate\Support\Facades\URL;
use Illuminate\Support\Str;
use Illuminate\Support\Facades\Auth;
use Illuminate\Validation\Rule;
use App\General\GeneralSettingsClass;

class ContactUsController extends Controller
{
    public $website_title = 'Yazi';
    public function index()
    {
        $meta_details = [
            'title' => 'Contact Us | ' . $this->website_title,
            'keywords' => 'contact tooltrede, tools, genuine, harware, makita, australia',
            'description' => 'Whole sale Hardware selling website',
            'author' => 'Yazi',
        ];
        return view('Website.GeneralPages.contact-us',compact('meta_details'));
    }

    public function store(Request $request)
    {
        $validated_data = $request->validate([
            'f_name' => 'required|string',
            'l_name' => 'nullable|string',
            'email' => 'required|string',
            'phone' => 'required|string',
            'subject' => 'required|string',
            'message' => 'required|string'
        ]);
        $contactuser = Contactu::create($validated_data);
        $data = GeneralSettings::where('option', '_header_logo')->orWhere('option', '_b_email')->orWhere('option', '_instagram_link')->orWhere('option', '_facebook_link')->orWhere('option', '_twitter_link')->orWhere('option', '_youtube_link')->get()->toArray();

        $admin_email_index = array_search('_b_email', array_column($data, 'option'));
        $header_logo_index = array_search('_header_logo', array_column($data, 'option'));
        $insta_link_index = array_search('_instagram_link', array_column($data, 'option'));
        $fb_link_index = array_search('_facebook_link', array_column($data, 'option'));
        $twitter_link_index = array_search('_twitter_link', array_column($data, 'option'));
        $youtube_link_index = array_search('_youtube_link', array_column($data, 'option'));

        $admin_email = $data[$admin_email_index]['value'];
        $logo = $data[$header_logo_index]['value'];
        $instagram_link = $data[$insta_link_index]['value'];
        $facebook_link = $data[$fb_link_index]['value'];
        $twitter_link = $data[$twitter_link_index]['value'];
        $youtube_link = $data[$youtube_link_index]['value'];

        if ($contactuser) {
            $params = [
                'subject' => 'Contact Us | ' . config('app.website_name'),
                'to' => $validated_data['email'],
                'blade' => 'contactus-user',
                'data' => [
                    'name' => $validated_data['f_name'] . " " . $validated_data['l_name'],
                    'url' => url('/'),
                    'logo' => $logo,
                    'instagram_link' => $instagram_link,
                    'facebook_link' => $facebook_link,
                    'twitter_link' => $twitter_link,
                    'youtube_link' => $youtube_link,
                    'admin_email' => $admin_email,
                ],
            ];
            // env('BUSINESS_EMAIL')

            $emailController = new EmailController();
            $paramsAdmin = [
                'subject' => 'New Contact Form Submission',
                'to' => $admin_email,
                'blade' => 'contact-us-admin',
                'data' => [
                    'name' => $validated_data['f_name'] . " " . $validated_data['l_name'],
                    'email' => $validated_data['email'],
                    'phone' => $validated_data['phone'],
                    'subject' => $validated_data['subject'],
                    'contact_message' => $validated_data['message'],
                    'url' => url('/'),
                    'logo' => $logo,
                ],
            ];
            $emailSentAdmin = $emailController->SendInstantEmail($paramsAdmin);
            $emailSentUser  = $emailController->SendInstantEmail($params);

                if ($emailSentUser && $emailSentAdmin) {
                    return response()->json([
                        'status' => 200,
                        'message' => 'Thanks To Contact Us, Your Query is forwarded to the support.',
                    ]);
                } else {
                    return response()->json([
                        'status' => 500,
                        'message' => 'Error, An Error Occurred while sending the email.',
                    ]);
                }
            return response()->json([
                        'status' => 200,
                        'message' => 'Thanks you for Contacting Us.',
                    ]);
        } else {
            return response()->json([
                'status' => 500,
                'message' => 'An Error Occurred, During creating user account.',
            ]);
        }
    }
}
